<script>
    import Paginate from "$/components/Paginate.svelte";
    import { getRoles } from "$/services/roles";
    import PageTitle from "$/components/PageTitle.svelte";
    import ModalRol from "./ModalRol.svelte";
    import { useLocation } from "svelte-navigator";
    import { getPermisosPath } from "$/services/usuarios";

    const limit = 15;
    let page = 1;
    let offset = 0;
    let count = 0;
    let ordering = 'id_rol'
    let roles = []
    let rol = null
    let loading = false;
    let escritura = false;
    let location = useLocation()

    getPermisosPath($location.pathname)
        .then(data => escritura = data.escritura)
        .catch(error => console.log({ error }))

    $: onPage(page)

    async function onPage(p) {
        try {
            loading = true
            offset = (p - 1) * limit;
            const data = await getRoles({ offset, limit, ordering })
            roles = data.results;
            count = data.count;
        } catch (error) {
            globalThis.toast.error(error)
        } finally {
            loading = false;
        }
    }

    function onEdita(item) {
        rol = item;
    }

    function onNuevo() {
        rol = {}
    }

    function onOrderBy(field) {
        ordering = ordering === field ? '-' + field : field;
        onPage(page)
    }
</script>

<PageTitle {loading}>Roles</PageTitle>

<div class="card">
    <div class="card-header">
        {#if escritura}
            <button class="btn btn-primary" on:click|preventDefault={onNuevo}>
                <i class="bi bi-plus-lg"></i> Nuevo
            </button>
        {/if}
    </div>
    <div class="card-body">
        <div class="table-responsive">
            <table class="table table-sm table-bordered">
                <thead>
                    <tr class="table-light">
                        <th style="width: 5%">Nro</th>
                        <th style="width: 5%">
                            <a href={"#"} on:click|preventDefault={() => onOrderBy('id_rol')}>ID</a>
                            {#if ordering === 'id_rol'}<i class="bi bi-caret-up-fill"></i>{/if}
                            {#if ordering === '-id_rol'}<i class="bi bi-caret-down-fill"></i>{/if}
                        </th>
                        <th>
                            <a href={"#"} on:click|preventDefault={() => onOrderBy('nombre_rol')}>Nombre</a>
                            {#if ordering === 'nombre_rol'}<i class="bi bi-caret-up-fill"></i>{/if}
                            {#if ordering === '-nombre_rol'}<i class="bi bi-caret-down-fill"></i>{/if}
                        </th>
                    </tr>
                </thead>
                <tbody>
                    {#each roles as app, index}
                    <tr>
                        <td class="table-light">{offset + index + 1}</td>
                        <td>{app.id_rol}</td>
                        <td><a href={"#"} on:click|preventDefault={() => onEdita(app)}>{app.nombre_rol}</a></td>
                    </tr>
                    {/each}
                </tbody>
            </table>
        </div>
    </div>
    <div class="card-footer d-flex">
        <a href={"#"} class="btn btn-outline-secondary me-3" on:click|preventDefault={() => onPage(page)}>
            <i class="bi bi-arrow-repeat"></i>
        </a>
        <Paginate
            forcePage={page}
            {limit}
            {count}
            on:page={ev => page = ev.detail}
        />
    </div>
</div>

{#if rol}
    <ModalRol {rol} on:close={() => rol = null} on:refresh={() => onPage(page)} {escritura} />
{/if}

<style>
    .table-responsive {
        max-height: calc(100vh - 300px);
    }
</style>